import numpy as np
from numpy import genfromtxt
import matplotlib.pyplot as plt

model_type = "lstmlast_"  
batch_size = 8
lr = 1e-4
hidden_size = 128
N = 1
user = 5
width = [-0.3, -0.2, -0.1, 0, 0.1, 0.2, 0.3]
act_series = 5

for act in range(1,act_series+1):
	rate_user_data_list = []
	for r in range(0,101,10):
		# read data
		print(r)
		user_data_list = []
		for i in range(user):
			model_data_list = []
			path = "result/"+"N"+ str(N) + "/" + model_type + "bs_" + str(batch_size) + '_lr_' + str(lr) + '_hidden_size_' + str(hidden_size) + '_N' + str(N) + "_result_user" + str(i) + "_rate__" + str(r) + "_act_" + str(act) +".csv"		
			data = genfromtxt(path, delimiter=',', skip_header =1)
			for j in range(7):			
				data_temp = data[[1+7*j+j,2+7*j+j,3+7*j+j,4+7*j+j,5+7*j+j,6+7*j+j,7+7*j+j],:][:,[2,4,6,7]]
				model_data_list.append(data_temp)
			model_data_list = np.concatenate(model_data_list, axis=0)
			user_data_list.append(model_data_list)
		model_data_list_total = np.stack(user_data_list)
		print(model_data_list_total.shape)
		mean_user_data = np.mean(model_data_list_total,axis=0)
		print(mean_user_data.shape)
		rate_user_data_list.append(mean_user_data)		

	color = ['royalblue', 'lightgreen', 'tomato', 'indigo', 'plum', 'darkorange', 'blue']
	legend = ['rule 1', 'rule 2', 'rule 3', 'rule 4', 'rule 5', 'rule 6', 'rule 7']
	fig, axs = plt.subplots(7, sharex=True, sharey=True)
	fig.set_figheight(14) # was 10
	fig.set_figwidth(20)

	for ax in range(7):
		y_total = []
		y_low_total = []
		y_high_total = []
		for j in range(7):
			y= []
			y_low = []
			y_high = []
			for i in range(len(rate_user_data_list)):
				y.append(rate_user_data_list[i][j+ax*7][0])
				y_low.append(rate_user_data_list[i][j+ax*7][2])
				y_high.append(rate_user_data_list[i][j+ax*7][3])
			y_total.append(y)
			y_low_total.append(y_low)	
			y_high_total.append(y_high)
			print()
			print(legend[ax])
			print("user mean of mean prob: ", np.mean(y))
			print("user mean of sd prob: ", np.std(y))
			
		for i in range(7):
			axs[ax].plot(range(0,101,10), y_total[i], color=color[i], label=legend[i])
			axs[ax].fill_between(range(0,101,10), y_low_total[i], y_high_total[i], color=color[i],alpha=0.3 )
			axs[ax].set_xticks(range(0,101,10))
			axs[ax].set_ylabel('prob', fontsize=26) # was 20
			axs[ax].set_title(legend[ax], color=color[ax], fontsize=26)
			
			
		#axs[0].text(-0.15, 1.2, 'True Intention:', horizontalalignment='center', verticalalignment='center', transform=axs[0].transAxes, fontsize= 36) # was -0.125 20
		#axs[ax].text(-0.15, 0.5, legend[ax], horizontalalignment='center', verticalalignment='center', transform=axs[ax].transAxes, fontsize= 36, color=color[ax])   # -0.125 20
		axs[ax].tick_params(axis='y', which='major', labelsize=18) # was 16
		axs[ax].tick_params(axis='x', which='major', labelsize=18) # was 16
		for tick in axs[ax].xaxis.get_major_ticks():
			tick.set_pad(20)
		
	plt.xlabel('Percentage of occurred actions in one action sequence', fontsize= 26) # was 20
	handles, labels = axs[0].get_legend_handles_labels()

	plt.xlim([0, 101])
	plt.ylim([0, 1.1])
	plt.tight_layout()
	plt.savefig("figure/"+"N"+ str(N) + "_ "+ model_type + "_bs_" + str(batch_size) + '_lr_' + str(lr) + '_hidden_size_' + str(hidden_size) + '_N' + str(N) + "_act_series" + str(act) + "_rate_ful_all_individuall_chiw.png", bbox_inches='tight')

	#plt.show()






